/**
 * Created by sangcixiang on 2016/8/9.
 */
angular.module("starter.directive", ['starter.services'])
    //.directive('hideTabs',function($rootScope){
    //  return {
    //    restrict:'AE',
    //    link:function($scope){
    //      $rootScope.hideTabs = 'tabs-item-hide';
    //      $scope.$on('$destroy',function(){
    //        $rootScope.hideTabs = '';
    //      })
    //    }
    //  }
    //});
    .directive('hideTabs', function($rootScope) {
        return {
            restrict: 'A',
            link: function(scope, element, attributes) {
                scope.$on('$ionicView.beforeEnter', function() {
                    scope.$watch(attributes.hideTabs, function(value){
                        $rootScope.hideTabs = value;
                    });
                });

                scope.$on('$ionicView.beforeLeave', function() {
                    $rootScope.hideTabs = false;
                });
            }
        };
    })
    .directive('fileModel', ['$parse', function ($parse) {
        return {
            restrict: 'A',
            link: function($scope ,element, attrs, ngModel) {

                var model = $parse(attrs.fileModel);
                var modelSetter = model.assign;
                element.bind('change', function(event){
                    $scope.$apply(function(){
                        modelSetter($scope, element[0].files[0]);
                    });
                    //附件预览
                    $scope.file = (event.srcElement || event.target).files[0];
                    $scope.getFile($scope.file,attrs.fileModel);
                });
            }
        };
    }])
  .directive('loadImage',['$parse', function ($parse,$http,configURL) {
    return {
      restrict: 'A',
      link: function($scope ,element, attrs) {

        var imageUrl =attrs.loadImage;



        var img = element[0];
        //img.setAttribute('crossOrigin', 'anonymous');
        img.crossOrigin = "*";
        var db = openDatabase('imgDB', '1.0', 'imgDB', 50 * 1024 * 1024);
        var md5 = imageUrl.MD5();
        db.transaction(function (context) {
          context.executeSql('CREATE TABLE IF NOT EXISTS imgTable (id integer PRIMARY KEY,name text NOT NULL,imgData blob NOT NULL)');
          context.executeSql('SELECT * FROM imgTable where name = ?',[md5], function (context, results) {
            var len = results.rows.length;
            //console.log(results.rows.item(i).imgData)
            if(len>0){
              var blob = results.rows.item(0).imgData;
              readBlobToDataUrl(blob,function(dataUrl){
                img.src = dataUrl;
              })
            }else{
              img.src = imageUrl;
              imageToDataWithBlob(element[0],function(blob){
                console.log(blob)
                context.executeSql('CREATE TABLE IF NOT EXISTS imgTable (id integer PRIMARY KEY,name text NOT NULL,imgData blob NOT NULL)');
                context.executeSql('INSERT INTO imgTable (name, imgData) VALUES (?,?)',[md5,blob]);
              })
            }
          },function(tx,result){
            //console.log(result)
          });
        });

        //图片转blob ;
        function imageToDataWithBlob(img,callBack){
          img.onload = function(){
            var canvas = document.createElement("canvas");
            var ctx = canvas.getContext('2d');
            ctx.canvas.width = img.width;
            ctx.canvas.height = img.height;
            //ctx.fillRect(0,0,img.width,img.height);
            ctx.drawImage(img,0,0,img.width,img.height);
            var dataUrl = canvas.toDataURL('image/png');
            var blob = dataUrlToBlob(dataUrl);
            callBack(blob);
          }
        }
        //blob 转data
        function readBlobToDataUrl(blob,callBack){
          var a = new FileReader();
          a.onload = function(e){
            callBack(e.target.result);
          }
          a.readAsDataURL(blob);
        }
        //blob 转data
        function dataUrlToBlob(dataUrl){
          var arr = dataUrl.split(','),mime = arr[0].match(/:(.*?);/)[1],
            bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
          while(n--){
            u8arr[n] = bstr.charCodeAt(n);
          }
          return new Blob([u8arr], {type:mime});
        }

        element.bind('change', function(event){
             console.log(event)
        });
      }
    };
  }])






















;
